bin_PROGRAMS = lttctl
bin_SCRIPTS = ltt-armall ltt-disarmall \
- ltt-armnetsync ltt-disarmnetsync \
ltt-armtap ltt-disarmtap
CLEANFILES = $(bin_SCRIPTS)
EXTRA_DIST = ltt-armall.sh ltt-disarmall.sh \
- ltt-armnetsync.sh ltt-disarmnetsync.sh \
ltt-armtap.sh ltt-disarmtap.sh
ltt-armall: ltt-armall.sh
cat $(srcdir)/ltt-disarmall.sh >> ltt-disarmall
chmod ugo+x ltt-disarmall
-ltt-armnetsync: ltt-armnetsync.sh
- rm -f ltt-armnetsync
- echo "#!"$(BASH) > ltt-armnetsync
- cat $(srcdir)/ltt-armnetsync.sh >> ltt-armnetsync
- chmod ugo+x ltt-armnetsync
-
-ltt-disarmnetsync: ltt-disarmnetsync.sh
- rm -f ltt-disarmnetsync
- echo "#!"$(BASH) > ltt-disarmnetsync
- cat $(srcdir)/ltt-disarmnetsync.sh >> ltt-disarmnetsync
- chmod ugo+x ltt-disarmnetsync
-
ltt-armtap: ltt-armtap.sh
rm -f ltt-armtap
echo "#!"$(BASH) > ltt-armtap
+#!/bin/bash
+# Copyright (C) 2009 Benjamin Poirier
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+
DEBUGFSROOT=$(grep ^debugfs /proc/mounts | head -1 | awk '{print $2}')
MARKERSROOT=${DEBUGFSROOT}/ltt/markers
-echo Connecting all markers
-
-for c in ${MARKERSROOT}/*; do
- case ${c} in
- ${MARKERSROOT}/metadata)
- ;;
- ${MARKERSROOT}/locking)
- ;;
- ${MARKERSROOT}/lockdep)
- ;;
- *)
- for m in ${c}/*; do
- echo Connecting ${m}
- echo 1 > ${m}/enable
- done
- ;;
+usage () {
+ echo "Usage: $0 [OPTION]..." > /dev/stderr
+ echo "Connect lttng markers" > /dev/stderr
+ echo "" > /dev/stderr
+ echo "Options:" > /dev/stderr
+ printf "\t-l Also activate locking markers (high traffic)\n" > /dev/stderr
+ printf "\t-n Also activate detailed network markers (large size)\n" > /dev/stderr
+ echo "" > /dev/stderr
+ printf "\t-q Quiet mode, suppress output\n" > /dev/stderr
+ printf "\t-h Print this help\n" > /dev/stderr
+ echo "" > /dev/stderr
+}
+
+if [ ! "$DEBUGFSROOT" ]; then
+ echo "Error: debugfs not mounted" > /dev/stderr
+ exit 1;
+fi
+
+if [ ! -d "$MARKERSROOT" ]; then
+ echo "Error: LTT trace controller not found (did you compile and load LTTng?)" > /dev/stderr
+ exit 1;
+fi
+
+while getopts "lnqh" options; do
+ case $options in
+ l) LOCKING="0";;
+ n) NETWORK="0";;
+ q) QUIET="0";;
+ h) usage;
+ exit 0;;
+ \?) usage;
+ exit 1;;
esac
done
+shift $(($OPTIND - 1))
+
+
+if [ ! $LOCKING ]; then
+ TESTS="${TESTS} -name lockdep -prune -o -name locking -prune -o"
+fi
+
+if [ ! $NETWORK ]; then
+ TESTS="${TESTS} -path '*/net/*_extended' -prune -o"
+fi
+
+while read -r -d $'\0' marker; do
+ if [ ! $QUIET ]; then
+ echo "Connecting ${marker%/enable}"
+ fi
+ echo 1 > $marker
+done < <(eval "find '$MARKERSROOT' $TESTS -name metadata -prune -o -name enable -print0")
+++ /dev/null
-DEBUGFSROOT=$(grep ^debugfs /proc/mounts | head -1 | awk '{print $2}')
-MARKERSROOT=${DEBUGFSROOT}/ltt/markers
-
-echo Connecting network synchronization markers
-
-for m in ${MARKERSROOT}/net/*_extended; do
- echo Connecting ${m}
- echo 1 > ${m}/enable
-done
+#!/bin/bash
+# Copyright (C) 2009 Benjamin Poirier
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+
DEBUGFSROOT=$(grep ^debugfs /proc/mounts | head -1 | awk '{print $2}')
MARKERSROOT=${DEBUGFSROOT}/ltt/markers
-echo Disconnecting all markers
-
-for c in ${MARKERSROOT}/*; do
- case ${c} in
- ${MARKERSROOT}/metadata)
- ;;
- ${MARKERSROOT}/locking)
- ;;
- ${MARKERSROOT}/lockdep)
- ;;
- *)
- for m in ${c}/*; do
- echo Disconnecting ${m}
- echo 0 > ${m}/enable
- done
- ;;
+usage () {
+ echo "Usage: $0 [OPTION]..." > /dev/stderr
+ echo "Disconnect lttng markers" > /dev/stderr
+ echo "" > /dev/stderr
+ echo "Options:" > /dev/stderr
+ printf "\t-q Quiet mode, suppress output\n" > /dev/stderr
+ printf "\t-h Print this help\n" > /dev/stderr
+ echo "" > /dev/stderr
+}
+
+if [ ! "$DEBUGFSROOT" ]; then
+ echo "Error: debugfs not mounted" > /dev/stderr
+ exit 1;
+fi
+
+if [ ! -d "$MARKERSROOT" ]; then
+ echo "Error: LTT trace controller not found (did you compile and load LTTng?)" > /dev/stderr
+ exit 1;
+fi
+
+while getopts "qh" options; do
+ case $options in
+ q) QUIET="0";;
+ h) usage;
+ exit 0;;
+ \?) usage;
+ exit 1;;
esac
done
+shift $(($OPTIND - 1))
+
+while read -r -d $'\0' marker; do
+ grep "^1$" "$marker" -q
+ if [ $? -ne 0 ]; then
+ continue
+ fi
+ if [ ! $QUIET ]; then
+ echo "Disconnecting ${marker%/enable}"
+ fi
+ echo 0 > $marker
+done < <(eval "find '$MARKERSROOT' -name metadata -prune -o -name enable -print0")
+++ /dev/null
-DEBUGFSROOT=$(grep ^debugfs /proc/mounts | head -1 | awk '{print $2}')
-MARKERSROOT=${DEBUGFSROOT}/ltt/markers
-
-echo Disconnecting network synchronization markers
-
-for m in ${MARKERSROOT}/net/*_extended; do
- echo Disconnecting ${m}
- echo 0 > ${m}/enable
-done